<template>
  <q-layout view="lHh Lpr lFf" v-if="storeSet">
    <q-header elevated class="bg-primary text-white">
      <q-toolbar>
        <q-btn
          dense
          flat
          @click="leftDrawerOpen = !leftDrawerOpen"
          round
          icon="menu"
        />
       
      </q-toolbar>
    </q-header>

    <q-drawer
      v-model="leftDrawerOpen"
      show-if-above
      bordered
      :width="250"
      :breakpoint="500"
      class="bg-grey-1 q-mt-md"
    >
    <q-scroll-area style="height: calc(100% - 150px); margin-top: 150px; border-right: 1px solid #ddd">
      <q-list>
        <EssentialLink
          v-for="link in essentialLinks"
          :key="link.title"
          v-bind="link"
        />
      </q-list>
    </q-scroll-area>
      <q-img class="absolute-top" src="https://cdn.quasar.dev/img/material.png" style="height: 150px">
          <div class="absolute-bottom bg-transparent">
            <q-avatar size="56px" class="q-mb-sm">
              <img src="https://cdn.quasar.dev/img/boy-avatar.png">
            </q-avatar>
            <div class="text-weight-bold">{{ $store.state.example.user.user.name }}</div>
            <div>{{ $store.state.example.user.user.maktab }} - maktab {{ $store.state.example.user.user.sinf }} - sinf</div>
          </div>
        </q-img>
    </q-drawer>
    <q-page-container v-if="storeSet">
      <router-view />
      <q-page-scroller style="width:20px;" position="bottom-left" :scroll-offset="150" :offset="[10, 10]">
            <q-btn fab icon="keyboard_arrow_up" color="blue" />
          </q-page-scroller>
    </q-page-container>
  </q-layout>
</template>

<script>
import EssentialLink from 'components/EssentialLink.vue'

import {mapActions} from 'vuex'
import axios from 'axios'

export default {
  name: 'MainLayout',
  components: { EssentialLink },
  data() {
    return {
      storeSet: false,
      menuItem: [],
      leftDrawerOpen: true,

      //essentialLinks: linksData,
      essentialLinks: [],
      menu:0,
    }
  },

    async mounted(){
    this.$q.loading.show()
    await this.AuthUser()

    //console.log(this.$store.state.example.user)
    var user_data = this.$store.state.example.userPermission;
    //console.log(user_data)
    var json = {}
    this.menuItem = []
    for(var i=0;i<user_data.length;i++){
      json = {
          title: user_data[i].title,
          icon: user_data[i].iconUrl,
          link: user_data[i].url,
        }
        if(user_data[i].read) this.menuItem.push(json)
    }
    this.menuItem.push({
      title: "Logout",
      icon: "logout",
      link: "logout"
    })
    this.essentialLinks = this.menuItem
    
  },

  methods:{
    ...mapActions('example', ['setUser']),
    async AuthUser(){
      await axios.get(this.$domen()+'user/auth_user').then((res) => {
        this.$q.loading.hide()
        this.setUser({user: res.data[0]})
        this.storeSet = true
      }).catch((e)=>{
        var res = e.response
        this.$q.loading.hide()
        if(e.status == 401){
          this.$e("You are not authorized")
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else{
          this.$e("Something Errors")
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }
      })
    }
  }
    
}
</script>

